classdef oscillodemo < handle
	properties
		Fs=11025;
		t,yy,meanyy,lineyy,linecursor1,linecursor2
		r,linemaxmin1,linemaxmin2,linetrig1,linetrig2
		linelsq,hdl,btn,triglevel,upedge,animation
		AC,uistartstop,uixcursor,uixcursortxt
		uimax,uimin,uitrig,uitrigtxt,uilsq,
		uilsqslider,uilsqstr,uiac,uidc,uiupedge,uidwnedge
		pupind,pdwnind
	end
	methods
		function this = oscillodemo
			close all;
			this.r = audiorecorder(this.Fs, 16, 1);
			recordblocking (this.r,0.5);
			y = getaudiodata(this.r, 'int16');
			this.t=((1:length(y))-1)/this.Fs;
			this.yy=double(y);
			this.meanyy=0;
			this.lineyy=plot(this.t,this.yy-this.meanyy);
			hold on
				this.linecursor1=plot(0,0,'g--');
				this.linecursor2=plot(0,0,'g--');
				this.linemaxmin1=plot(0,0,'r--');
				this.linemaxmin2=plot(0,0,'r--');
				this.linetrig1=plot(0,0,'g--');
				this.linetrig2=plot(0,0,'go');
				this.linelsq=plot(0,0,'r');
			hold off
			this.hdl=[];this.btn=0;this.triglevel=[];
			this.upedge=1;this.animation=1;this.AC=0;
			gf=gcf;ga=gca;
			gf.Units='normal';ga.Units='normal';
			gf.WindowButtonDownFcn=@(~,~)adevent(this,1);
			gf.WindowButtonMotionFcn=@(~,~)adevent(this,2);
			gf.WindowButtonUpFcn=@(~,~)adevent(this,0);
			ga.Position=[0.2,.12,.75,0.815];
			this.uistartstop=uicontrol('Style','pushbutton');
			this.uistartstop.Units='normalized';
			this.uistartstop.Position=[0,0.85,0.11,0.03];
			this.uistartstop.String='Stop';
			this.uistartstop.Callback=@(~,~)adupdateevent(this,0,this.AC,this.upedge);
			this.uixcursor=uicontrol('Style','checkbox');
			this.uixcursor.Units='normalized';
			this.uixcursor.Position=[0,0.80,0.11,0.03];
			this.uixcursor.String='x corsor';
			this.uixcursor.Callback=@(~,~)adupdateevent(this,0,this.AC,this.upedge);
			this.uixcursortxt=uicontrol('Style','edit');
			this.uixcursortxt.Units='normalized';
			this.uixcursortxt.Position=[0,0.75,0.17,0.05];
			this.uimax=uicontrol('Style','checkbox');
			this.uimax.Units='normalized';
			this.uimax.Position=[0,0.70,0.11,0.03];
			this.uimax.String='Max';
			this.uimax.Callback=@(~,~)adupdate(this);
			this.uimin=uicontrol('Style','checkbox');
			this.uimin.Units='normalized';
			this.uimin.Position=[0,0.65,0.11,0.03];
			this.uimin.String='Min';
			this.uimin.Callback=@(~,~)adupdate(this);
			this.uitrig=uicontrol('Style','checkbox');
			this.uitrig.Units='normalized';
			this.uitrig.Position=[0,0.60,0.17,0.03];
			this.uitrig.String='trig level';
			this.uitrig.Callback=@(~,~)adupdateevent(this,0,this.AC,this.upedge);
			this.uitrigtxt=uicontrol('Style','edit','Units','normalized');
			this.uitrigtxt.Position=[0,0.55,0.17,0.05];
			this.uitrigtxt.String='';
			this.uilsq=uicontrol('Style','checkbox','Units','normalized');
			this.uilsq.Position=[0.02,0.50,0.15,0.03];
			this.uilsq.String='ls curvefit';
			this.uilsqslider=uicontrol('Style','slider','Units','normalized');
			this.uilsqslider.Position=[0,0.45,0.17,0.03];
			this.uilsqslider.Min=0;
			this.uilsqslider.Max=6;
			this.uilsqslider.Value=0;
			this.uilsqslider.Callback=@(~,~)adupdate(this);
			this.uilsqstr=uicontrol('Style','edit','Units','normalized');
			this.uilsqstr.Position=[0,.40,0.17,0.05];
			this.uiac=uicontrol('style','radiobutton','Units','normalized');
			this.uiac.Position=[0,0.30,0.08,0.03];
			this.uiac.String='AC';
			this.uiac.Value=1;
			this.uiac.Callback=@(~,~)adupdateevent(this,this.animation,1,this.upedge);
			this.uidc=uicontrol('Style','radiobutton','Units','normalized');
			this.uidc.Position=[0.09,0.30,0.08,0.03];
			this.uidc.String='DC';
			this.uidc.Callback=@(~,~)adupdateevent(this,this.animation,0,this.upedge);
			this.uiupedge=uicontrol('Style','radiobutton','String',' ');
			this.uiupedge.Position=[20,20,80,20];
			this.uiupedge.Value=1;
			this.uiupedge.Callback=@(~,~)adupdateevent(this,this.animation,this.AC,1);
			this.uidwnedge=uicontrol('Style','radiobutton','String',' ');
			this.uidwnedge.Position=[120,20,80,20];
			this.uidwnedge.Value=0;
			this.uidwnedge.Callback=@(~,~)adupdateevent(this,this.animation,this.AC,0);
			adupdate(this);
			adrun(this);
		end
		function this = adsetpara(this,animation,AC,upedge)
			this.animation = animation;
			this.AC = AC;
			this.upedge = upedge;
		end
		function this=adupdateevent(this,animation,AC,upedge)
			adsetpara(this,animation,AC,upedge);
			adupdate(this);
			adevent(this,this.btn);
		end
		function this = adupdate(this)
% AC/DC init %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			if this.AC==1
				this.uidc.Value=0;
				this.uiac.Value=1;
				this.meanyy = mean(this.yy);
			else
				this.uidc.Value=1;
				this.uiac.Value=0;
				this.meanyy = 0;
			end
			[maxyval,~]=max(this.yy-this.meanyy);
			[minyval,~]=min(this.yy-this.meanyy);
			ylim([-abs(maxyval),abs(maxyval)]);
			this.lineyy.YData=this.yy-this.meanyy;
%% maxmin%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			if this.uimax.Value==1
				this.linemaxmin1.XData=this.t([1,end]);
				this.linemaxmin1.YData=[maxyval,maxyval]-this.meanyy;
			else
				this.linemaxmin1.XData=[];this.linemaxmin1.YData=[];
			end
			if this.uimin.Value==1
				this.linemaxmin2.XData=this.t([1,end]);
				this.linemaxmin2.YData=[minyval,minyval]-this.meanyy;
			else
				this.linemaxmin2.XData=[];this.linemaxmin2.YData=[];
			end
%% for updown edge %%%%%%%%%%%%%%%%%%%%%%%%%%%
			if this.upedge==1
				this.uiupedge.Value=1;
				this.uidwnedge.Value=0;
			else
				this.uiupedge.Value=0;
				this.uidwnedge.Value=1;
			end
%% for trigger%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			if this.uitrig.Value ==1
				if isempty(this.triglevel)
					this.linetrig1.XData=xlim;
					this.linetrig1.YData=[0,0];
				else
					this.linetrig1.XData=xlim;
					this.linetrig1.YData=this.triglevel([1,1]);
					new_yy=conv(this.yy,ones(1,9)/9);
					plogicval=(new_yy(5:(end-4)) >= this.triglevel(1));
					if this.uiupedge.Value ==1
						this.pupind=strfind(plogicval(:)',[0,1]);
						this.linetrig2.XData=this.t(this.pupind);
						this.linetrig2.YData=this.yy(this.pupind)-this.meanyy;
					else
						this.pdwnind=strfind(plogicval(:)',[1,0]);
						this.linetrig2.XData=this.t(this.pdwnind);
						this.linetrig2.YData=this.yy(this.pdwnind)-this.meanyy;
					end
					if ~isempty(this.pupind)
% diff cannot handle less than 1 data
						if length(this.pupind) > 1
							this.uitrigtxt.String=[num2str(mean(diff(this.t(this.pupind)))),'sec'];
						end
					end
				end
			else
				this.linetrig1.XData=[];this.linetrig1.YData=[];
				this.linetrig2.XData=[];this.linetrig2.YData=[];
				this.uitrigtxt.String='';
			end
% for lsq curvefit%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			if this.uilsq.Value== 1
				n=round(this.uilsqslider.Value);
				A=this.t(:).^n;
				for i=(n-1):-1:0
					A=[A,this.t(:).^i];
				end
				B=this.yy(:)-this.meanyy;
				this.linelsq.XData=this.t;
				this.linelsq.YData=A*(A\B);
				lsqpara=A\B;
				lsqstr=['y='];
				for i=1:n
					if lsqpara(i)>0,pmstr='+';
					else pmstr='-';end
					lsqstr=[lsqstr,pmstr,num2str(abs(lsqpara(i))),'x^',num2str(n+1-i)];
				end
				if lsqpara(n+1)>0,pmstr='+';
				else pmstr='-';end
				lsqstr=[lsqstr,pmstr,num2str(abs(lsqpara(n+1)))];
				legend('y',lsqstr);
				this.uilsqstr.String=[' =',num2str(n)];
			else
				this.linelsq.XData=[];this.linelsq.YData=[];
			end
% cursor init%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			if this.uixcursor.Value==1
				this.linecursor1.XData=[0.2,0.2];
				this.linecursor1.YData=ylim;
				this.linecursor2.XData=[0.3,0.3];
				this.linecursor2.YData=ylim;
				this.uixcursortxt.String='0.1 sec';
			else
				this.linecursor1.XData=[];this.linecursor1.YData=[];
				this.linecursor2.XData=[];this.linecursor2.YData=[];
				this.uixcursortxt.String='';
			end
		end
		function this = adevent(this,btn)
			this.btn = btn;
% for animation %%%%%%%%%%%%%%%%%%%%%%%%
			if this.animation == 0
				this.uistartstop.String='start';
				this.uistartstop.Callback=@(~,~)adrun(this);
				gf=gcf;
				gf.WindowButtonDownFcn=@(~,~)adevent(this,1);
				gf.WindowButtonMotionFcn=@(~,~)adevent(this,2);
				gf.WindowButtonUpFcn=@(~,~)adevent(this,0);
			end
% for mouse event %%%%%%%%%%%%%%%%%%%%%%%%%%
			switch(this.btn)
				case 0
					if ~isempty(this.hdl)
						if this.hdl == this.linetrig1
							new_yy=conv(this.yy,ones(1,9)/9);
							plogicval=(new_yy(5:(end-4)) >= this.triglevel(1));
							this.pupind=strfind(plogicval(:)',[0,1]);
							this.pdwnind=strfind(plogicval(:)',[1,0]);
							if this.uiupedge.Value ==1
								this.linetrig2.XData=this.t(this.pupind);
								this.linetrig2.YData=this.yy(this.pupind)-this.meanyy;
							else
								this.linetrig2.XData=this.t(this.pdwnind);
								this.linetrig2.YData=this.yy(this.pdwnind)-this.meanyy;
							end
							if ~isempty(this.pupind)
								if length(this.pupind) > 1
									[' gKx',num2str(this.triglevel(1)),' ώ',num2str(mean(diff(this.t(this.pupind))))]
								end
							end
						end
						this.hdl.LineWidth=1;
					end
					this.hdl = [];
				case 1
					if (gco == this.linetrig1) this.hdl=this.linetrig1;end
					if (gco == this.linecursor1) this.hdl=this.linecursor1;end
					if (gco == this.linecursor2) this.hdl=this.linecursor2;end
					if ~isempty(this.hdl) this.hdl.LineWidth=5;end
				case 2
					ga=gca;
					XX=ga.CurrentPoint;
					if ~isempty(this.hdl)
						if this.hdl == this.linetrig1
							this.hdl.XData=xlim;
							this.hdl.YData=XX(1,[2,2]);
							this.triglevel=this.hdl.YData;
							this.uitrigtxt.String=num2str(this.triglevel(1));
						else
							this.hdl.XData=XX(1,[1,1]);
							this.hdl.YData=ylim;
							haba=this.linecursor1.XData-this.linecursor2.XData;
							if ~isempty(haba)
								this.uixcursortxt.String=[num2str(abs(haba(1))),'sec'];
							end
						end
					end
			end
		end
		function this = adrun(this)
			this.animation = 1;
			gf=gcf;gf.Interruptible='on';
			gf.WindowButtonDownFcn=@(~,~)adsetpara(this,0,this.AC,this.upedge);
			this.uistartstop.String='stop';
			this.uistartstop.Callback=@(~,~)adupdateevent(this,0,this.AC,this.upedge);
			while (this.animation)
				recordblocking (this.r,0.5);
				y = getaudiodata(this.r, 'int16');
				this.yy=double(y);
				adupdate(this);
				drawnow;
			end;
			gf.Interruptible='on';
			gf.WindowButtonDownFcn=@(~,~)adrun(this);
		end
	end
end
